-- Visitor Radar
-- by Jadya
-- EU-Well of Eternity

local addonName, addonTable = ...
local L = addonTable.L -- localization
local addon = VisitorRadar

local questionmark = "Interface\\Icons\\INV_Misc_QuestionMark"
local noportrait = "Interface\\Garrison\\Portraits\\FollowerPortrait_NoPortrait"

local pool = {}
local function getframe(i, parent)
 if not pool[i] then
  pool[i] = CreateFrame("Frame", nil, parent)
  pool[i].tex = pool[i]:CreateTexture()
  pool[i].tex:SetAllPoints()
 end
 
 return pool[i]
end

function addonTable:ToggleButton(name, hide)
 for _,v in pairs(pool) do
  if v.fullName == name then
   if hide or not VisitorRadar_Options["show_in_guildframe"] then
    v:Hide()
   else
    v:Show()
   end
  end
 end
end

local function gr_update()
 local scrollFrame = GuildRosterContainer
 local offset = HybridScrollFrame_GetOffset(scrollFrame)
 local buttons = scrollFrame.buttons
 local numButtons = #buttons
 local button, index, found

 for i = 1, 4 do
  local col = _G["GuildRosterColumnButton"..i]
  if col and col:GetText() == CLASS_ABBR then
   found = true
  end
 end
   
 for i = 1, numButtons do
  button = buttons[i]
  local f = getframe(i, button)
  index = offset + i
  --local fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName, achievementPoints, achievementRank, isMobile, canSoR, repStanding = GetGuildRosterInfo(index)
  local fullName = GetGuildRosterInfo(index)
  
  f.fullName = fullName
  local ct = VisitorRadar_CharData[fullName]
 
  if found and VisitorRadar_Options["show_in_guildframe"] and ct and ct.t > time() and ct.visitor.id then
   local shortName = strsplit("-", fullName)
   local size = button:GetHeight() - 2
   f:SetSize(size, size)
   f:SetPoint("LEFT", button.icon, "RIGHT", 2, 0)
   local d = addon.NPCs[ct.visitor.id]
   local portrait = d and d.portrait
   f.tex:SetTexture(portrait or noportrait) -- .. that is the question :p
   f:SetScript("OnEnter", function(self)
     GameTooltip:ClearLines()
	 GameTooltip:SetOwner(self, "TOP")
	 GameTooltip:AddDoubleLine("|cffffd700"..CHARACTER.."|r","|cffFFFFFF"..shortName.."|r")
	 GameTooltip:AddDoubleLine("|cffffd700".."Npc".."|r","|cffFFFFFF"..L.ID2Name(ct.visitor.id).."|r")
	 GameTooltip:AddDoubleLine(GUILDINFOTAB_INFO,d and "|cffFFFFFF"..d.duty.."|r" or "")
	 if ct.visitor.quests and ct.visitor.quests[1] then
	  GameTooltip:AddLine(" ")
	  for _,v in pairs(ct.visitor.quests) do
	   GameTooltip:AddDoubleLine("|cffffd700"..BATTLE_PET_SOURCE_2.."|r", "|cffFFFFFF"..v.."|r")
	  end
	 end
	 if ct.pet_tamer then
 	  GameTooltip:AddLine(" ")
	  GameTooltip:AddLine("|cff00FF00"..addon.pet_tamer_name.."|r |cffFFFFFF"..AVAILABLE.."|r", v)
	 end
	 GameTooltip:Show()
 	end)
   f:SetScript("OnLeave", function(self)
     GameTooltip:Hide()
 	end)
   f:Show()
  else
   f:Hide()
  end
 end
end

addon.eventframe:RegisterEvent("ADDON_LOADED")
addon.eventframe:RegisterEvent("GUILD_ROSTER_UPDATE")
function addon.eventframe.ADDON_LOADED(...)
 if ... == "Blizzard_GuildUI" then
  addonTable:SetupCheckbox()
  GuildRosterContainer:HookScript("OnVerticalScroll", gr_update)
  hooksecurefunc("GuildRoster_Update", gr_update)
 end
end

local delayframe = CreateFrame("Frame")
local counter = 0
local rnd = math.random(200) / 100
delayframe:SetScript("OnUpdate", function(self, elapsed) 
  counter = counter + elapsed
  if counter > rnd then
   addon:Pulse()
   delayframe:Hide()
   counter = 0
  end
 end)
delayframe:Hide()

function addon.eventframe.GUILD_ROSTER_UPDATE(...)
 -- randomly delayed pulse to avoid a mass guild spam at the same moment
 delayframe:Show()
end